package de.zuim.ledcontrol.effects;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

import static de.zuim.ledcontrol.LEDControl.HEIGHT;
import static de.zuim.ledcontrol.LEDControl.WIDTH;

public class AudioVolumeEffect extends AudioFFTEffect {

	@Override
	public String getDescription() {
		return "Audio Volume";
	}

	List<Integer> volHistory = new ArrayList<>();
	long timeDeltaSum = 0;

	@Override
	public void render(long timeDelta, Graphics g) {
		timeDeltaSum += timeDelta;

		if (fbuf != null) {
			float avg = 0;
			float max = 0;
			for (float v : fbuf) {
				avg += Math.abs(v);
				if (v > max) {
					max = v;
				}
			}
			avg /= fbuf.length;
			volHistory.add((int) (5 * avg));
		}

		if (volHistory.size() > WIDTH) {
			volHistory.remove(0);
		}

		for (int x = 0; x < volHistory.size(); x++) {

			g.setColor(new Color((int) ((Math.abs(volHistory.get(x)) + 1) * ((WIDTH - x) / (float) WIDTH)), 2, 0));
			g.drawRect(WIDTH - x - 1, HEIGHT - volHistory.get(x), 0, HEIGHT);
		}
	}

}
